Index: java/main/src/main/java/com/framsticks/remote/RemoteTree.java
===================================================================
--- java/main/src/main/java/com/framsticks/remote/RemoteTree.java	(revision 99)
+++ java/main/src/main/java/com/framsticks/remote/RemoteTree.java	(revision 100)
@@ -15,9 +15,13 @@
 import com.framsticks.params.types.EventParam;
 import com.framsticks.params.types.ProcedureParam;
+import com.framsticks.parsers.Loaders;
 import com.framsticks.parsers.MultiParamLoader;
 import com.framsticks.core.Tree;
 import com.framsticks.util.*;
+import com.framsticks.util.dispatching.AtOnceDispatcher;
 import com.framsticks.util.dispatching.Dispatching;
 import com.framsticks.util.dispatching.Dispatching.DispatcherWaiter;
+import com.framsticks.util.dispatching.DispatchingFuture;
+import com.framsticks.util.dispatching.ExceptionResultHandler;
 import com.framsticks.util.dispatching.Future;
 import com.framsticks.util.dispatching.FutureHandler;
@@ -34,5 +38,6 @@
 import javax.annotation.Nonnull;
 
-import org.apache.log4j.Logger;
+import org.apache.logging.log4j.Logger;
+import org.apache.logging.log4j.LogManager;
 
 /**
@@ -42,5 +47,5 @@
 public final class RemoteTree extends AbstractTree implements JoinableParent {
 
-	private final static Logger log = Logger.getLogger(RemoteTree.class);
+	private final static Logger log = LogManager.getLogger(RemoteTree.class);
 
 	protected ClientSideManagedConnection connection;
@@ -62,4 +67,5 @@
 	public void setConnection(final ClientSideManagedConnection connection) {
 		this.connection = connection;
+		this.connection.setExceptionHandler(this);
 	}
 
@@ -74,19 +80,38 @@
 	}
 
-	@Override
-	public void get(final Path path, final ValueParam param, final Future<Object> future) {
-		assert isActive();
-		assert param != null;
-		// assert path.isResolved();
-		//TODO only do that if needed
-		connection.send(new GetRequest().field(param.getId()).path(path.getTextual()), this, new ClientSideResponseFuture(future) {
-			@Override
-			protected void processOk(Response response) {
-				assert isActive();
-				processFetchedValues(path, response.getFiles());
-				future.pass(bindAccess(path.tryResolveIfNeeded()).get(param, Object.class));
-			}
-		});
-	}
+	protected ExceptionResultHandler pathRemoveHandler(final Path path, final ExceptionResultHandler handler) {
+		return new ExceptionResultHandler() {
+
+			@Override
+			public void handle(final FramsticksException exception) {
+				Dispatching.dispatchIfNotActive(RemoteTree.this, new RunAt<RemoteTree>(RemoteTree.this) {
+
+					@Override
+					protected void runAt() {
+						assert path.getTree().isActive();
+						log.info("path is invalid (removing): {}", path);
+						bindAccess(path.getUnder()).set(path.getTop().getParam(), null);
+						handler.handle(exception);
+					}
+				});
+			}
+		};
+	}
+
+	// @Override
+	// public void get(final Path path, final ValueParam param, final Future<Object> future) {
+	//	assert isActive();
+	//	assert param != null;
+	//	// assert path.isResolved();
+	//	//TODO only do that if needed
+	//	connection.send(new GetRequest().field(param.getId()).path(path.getTextual()), this, new ClientSideResponseFuture(pathRemoveHandler(path, future)) {
+	//		@Override
+	//		protected void processOk(Response response) {
+	//			assert isActive();
+	//			processFetchedValues(path, response.getFiles());
+	//			future.pass(bindAccess(path.tryResolveIfNeeded()).get(param, Object.class));
+	//		}
+	//	});
+	// }
 
 	protected final Map<String, Set<Future<FramsClass>>> infoRequests = new HashMap<String, Set<Future<FramsClass>>>();
@@ -103,10 +128,10 @@
 		}
 
-		log.debug("issuing info request for " + name);
+		log.debug("issuing info request for {}", name);
 		final Set<Future<FramsClass>> futures = new HashSet<Future<FramsClass>>();
 		futures.add(future);
 		infoRequests.put(name, futures);
 
-		final Future<FramsClass> compositeFuture = new Future<FramsClass>() {
+		final Future<FramsClass> compositeFuture = DispatchingFuture.create(this, new Future<FramsClass>() {
 
 			@Override
@@ -122,4 +147,5 @@
 			protected void result(FramsClass framsClass) {
 				assert isActive();
+				putInfoIntoCache(framsClass);
 				infoRequests.remove(name);
 				for (Future<FramsClass> f : futures) {
@@ -127,11 +153,11 @@
 				}
 			}
-		};
+		});
 
 		//TODO: if the info is in the cache, then don't communicate
-		connection.send(new InfoRequest().path(path.getTextual()), this, new ClientSideResponseFuture(compositeFuture) {
+		connection.send(new InfoRequest().path(path.getTextual()), AtOnceDispatcher.getInstance(), new ClientSideResponseFuture(compositeFuture) {
 			@Override
 			protected void processOk(Response response) {
-				assert isActive();
+				assert connection.getReceiverDispatcher().isActive();
 
 				if (response.getFiles().size() != 1) {
@@ -141,5 +167,5 @@
 					throw new FramsticksException().msg("path mismatch").arg("returned path", response.getFiles().get(0).getPath());
 				}
-				FramsClass framsClass = processFetchedInfo(RemoteTree.this, response.getFiles().get(0));
+				FramsClass framsClass = Loaders.loadFramsClass(response.getFiles().get(0).getContent());
 
 				CompositeParam thisParam = path.getTop().getParam();
@@ -155,17 +181,16 @@
 	public void get(final Path path, final Future<Path> future) {
 		assert isActive();
-
-		log.trace("fetching values for " + path);
-		findInfo(path, new FutureHandler<FramsClass>(future) {
+		final ExceptionResultHandler remover = pathRemoveHandler(path, future);
+
+		log.trace("fetching values for {}", path);
+		findInfo(path, new FutureHandler<FramsClass>(remover) {
 			@Override
 			protected void result(FramsClass result) {
 
-				connection.send(new GetRequest().path(path.getTextual()), RemoteTree.this, new ClientSideResponseFuture(future) {
+				final Access access = registry.prepareAccess(path.getTop().getParam());
+				connection.send(new GetRequest().path(path.getTextual()), AtOnceDispatcher.getInstance(), new ClientSideResponseFuture(remover) {
 					@Override
 					protected void processOk(Response response) {
-						assert isActive();
-						Path p = path.tryResolveIfNeeded();
-						processFetchedValues(p, response.getFiles());
-						future.pass(p.tryResolveIfNeeded().assureResolved());
+						processFetchedValues(path, response.getFiles(), access, future);
 					}
 				});
@@ -179,5 +204,5 @@
 		final Integer flag = bindAccess(path).set(param, value);
 
-		log.trace("storing value " + param + " for " + path);
+		log.trace("storing value {} for {}", param, path);
 		//TODO break in passing exception handler is here
 		connection.send(new SetRequest().value(value.toString()).field(param.getId()).path(path.getTextual()), this, new ClientSideResponseFuture(future) {
@@ -274,5 +299,5 @@
 							return;
 						}
-						AccessInterface access = registry.createAccess(argumentType);
+						Access access = registry.createAccess(argumentType);
 						Object argument = access.createAccessee();
 						access.select(argument);
@@ -282,9 +307,9 @@
 						A typedArgument = argumentType.cast(argument);
 
-						// log.info("executing event with argument " + argumentType);
+						// log.info("executing event with argument {}", argumentType);
 						MultiParamLoader loader = new MultiParamLoader();
 						loader.setNewSource(file.getContent());
 						loader.addBreakCondition(MultiParamLoader.Status.AfterObject);
-						loader.addAccessInterface(access);
+						loader.addAccess(access);
 						loader.go();
 
Index: java/main/src/main/java/com/framsticks/running/ExternalProcess.java
===================================================================
--- java/main/src/main/java/com/framsticks/running/ExternalProcess.java	(revision 99)
+++ java/main/src/main/java/com/framsticks/running/ExternalProcess.java	(revision 100)
@@ -12,5 +12,6 @@
 
 
-import org.apache.log4j.Logger;
+import org.apache.logging.log4j.Logger;
+import org.apache.logging.log4j.LogManager;
 
 import com.framsticks.params.annotations.AutoAppendAnnotation;
@@ -31,5 +32,5 @@
 @FramsClassAnnotation
 public class ExternalProcess extends AbstractJoinable implements JoinableParent {
-	private static final Logger log = Logger.getLogger(ExternalProcess.class);
+	private static final Logger log = LogManager.getLogger(ExternalProcess.class);
 
 	protected List<String> arguments = new ArrayList<>();
@@ -83,5 +84,5 @@
 			try {
 				while ((line = output.readLine()) != null) {
-					log.trace("read line: " + line);
+					log.trace("read line: {}", line);
 					synchronized (listeners) {
 						for (OutputListener l : listeners) {
@@ -98,8 +99,8 @@
 				throw new FramsticksException().msg("failed to wait for process").cause(e);
 			}
-			log.debug("process ended " + this);
+			log.debug("process ended {}", this);
 			// process = null;
 		} catch (FramsticksException e) {
-			log.error("exception caught in process " + this, e);
+			log.error("exception caught in process {}", this, e);
 		}
 		interrupt();
@@ -119,5 +120,5 @@
 	@Override
 	protected void joinableStart() {
-		log.debug("running process with arguments: " + arguments);
+		log.debug("running process with arguments: {}", arguments);
 		builder.command(arguments);
 		try {
Index: java/main/src/main/java/com/framsticks/running/LoggingOutputListener.java
===================================================================
--- java/main/src/main/java/com/framsticks/running/LoggingOutputListener.java	(revision 99)
+++ java/main/src/main/java/com/framsticks/running/LoggingOutputListener.java	(revision 100)
@@ -1,5 +1,6 @@
 package com.framsticks.running;
 
-import org.apache.log4j.Logger;
+import org.apache.logging.log4j.Logger;
+import org.apache.logging.log4j.LogManager;
 
 import com.framsticks.params.annotations.FramsClassAnnotation;
@@ -8,5 +9,5 @@
 public class LoggingOutputListener implements OutputListener {
 	private static final Logger log =
-		Logger.getLogger(LoggingOutputListener.class);
+		LogManager.getLogger(LoggingOutputListener.class);
 
 
Index: java/main/src/main/java/com/framsticks/test/TestChild.java
===================================================================
--- java/main/src/main/java/com/framsticks/test/TestChild.java	(revision 100)
+++ java/main/src/main/java/com/framsticks/test/TestChild.java	(revision 100)
@@ -0,0 +1,47 @@
+package com.framsticks.test;
+
+import com.framsticks.core.ListChange;
+import com.framsticks.params.annotations.FramsClassAnnotation;
+import com.framsticks.params.annotations.ParamAnnotation;
+
+@FramsClassAnnotation
+public class TestChild {
+
+	protected String name = "child";
+
+	protected String uid;
+	protected final TestClass parent;
+	/**
+	 *
+	 */
+	public TestChild(TestClass parent) {
+		this.parent = parent;
+		this.uid = "c" + (parent.counter++);
+	}
+
+	/**
+	 * @return the name
+	 */
+	@ParamAnnotation
+	public String getName() {
+		return name;
+	}
+
+	/**00:10:00
+	 * @param name the name to set
+	 */
+	@ParamAnnotation
+	public void setName(String name) {
+		this.name = name;
+		parent.fireChildrenChange(this, ListChange.Action.Modify);
+	}
+
+	/**
+	 * @return the uid
+	 */
+	@ParamAnnotation
+	public String getUid() {
+		return uid;
+	}
+
+}
Index: java/main/src/main/java/com/framsticks/test/TestClass.java
===================================================================
--- java/main/src/main/java/com/framsticks/test/TestClass.java	(revision 99)
+++ java/main/src/main/java/com/framsticks/test/TestClass.java	(revision 100)
@@ -1,18 +1,39 @@
 package com.framsticks.test;
 
+import java.util.Collections;
 import java.util.LinkedList;
 import java.util.List;
+import java.util.Map;
 
-import org.apache.log4j.Logger;
+import org.apache.logging.log4j.Logger;
+import org.apache.logging.log4j.LogManager;
 
+import com.framsticks.core.ListChange;
 import com.framsticks.params.EventListener;
+import com.framsticks.params.UniqueListAccess;
 import com.framsticks.params.annotations.FramsClassAnnotation;
 import com.framsticks.params.annotations.ParamAnnotation;
 import com.framsticks.params.types.ProcedureParam;
 
-@FramsClassAnnotation(order = {"name", "history", "history_changed", "appendHistory", "resetHistory"}, register = {ChangeEvent.class})
+@FramsClassAnnotation(
+	order = {
+		"name",
+		"history",
+		"history_changed",
+		"appendHistory",
+		"resetHistory",
+		"children",
+		"createChild",
+		"children_changed"
+	},
+	register = {
+		ChangeEvent.class,
+		TestChild.class,
+		ListChange.class
+	}
+)
 public class TestClass {
 	private static final Logger log =
-		Logger.getLogger(TestClass.class);
+		LogManager.getLogger(TestClass.class);
 
 
@@ -20,4 +41,14 @@
 	protected String history = "initial|";
 	protected final List<EventListener<ChangeEvent>> historyListeners = new LinkedList<>();
+	protected final List<EventListener<ListChange>> childrenListeners = new LinkedList<>();
+
+	protected final Map<String, TestChild> children = UniqueListAccess.createMap(TestChild.class, this);
+	protected int counter = 0;
+
+	/**
+	 *
+	 */
+	public TestClass() {
+	}
 
 	/**
@@ -53,7 +84,15 @@
 	}
 
+	/**
+	 * @return the children
+	 */
+	@ParamAnnotation
+	public Map<String, TestChild> getChildren() {
+		return Collections.unmodifiableMap(children);
+	}
+
 	@ParamAnnotation(paramType = ProcedureParam.class)
 	public int appendHistory(String line) {
-		log.debug("appending '" + line + "'");
+		log.debug("appending '{}'", line);
 		history = history + line + "|";
 		fireHistoryChange();
@@ -68,4 +107,12 @@
 	}
 
+	@ParamAnnotation(paramType = ProcedureParam.class)
+	public void createChild(String name) {
+		TestChild child = new TestChild(this);
+		child.name = name;
+		children.put(child.getUid(), child);
+		fireChildrenChange(child, ListChange.Action.Add);
+	}
+
 	protected void fireHistoryChange() {
 		for (EventListener<ChangeEvent> l : historyListeners) {
@@ -73,4 +120,11 @@
 			event.history = history;
 			l.action(event);
+		}
+	}
+
+	protected void fireChildrenChange(TestChild child, ListChange.Action action) {
+		ListChange change = new ListChange(action, UniqueListAccess.getNumberInMap(children, child), child.getUid());
+		for (EventListener<ListChange> l : childrenListeners) {
+			l.action(change);
 		}
 	}
@@ -86,4 +140,14 @@
 	}
 
+	@ParamAnnotation(id = "children_changed")
+	public void addChildrenListener(EventListener<ListChange> listener) {
+		childrenListeners.add(listener);
+	}
+
+	@ParamAnnotation(id = "children_changed")
+	public void removeChildrenListener(EventListener<ListChange> listener) {
+		childrenListeners.remove(listener);
+	}
+
 	@Override
 	public String toString() {
Index: java/main/src/main/java/com/framsticks/util/Logging.java
===================================================================
--- java/main/src/main/java/com/framsticks/util/Logging.java	(revision 99)
+++ java/main/src/main/java/com/framsticks/util/Logging.java	(revision 100)
@@ -1,5 +1,5 @@
 package com.framsticks.util;
 
-import org.apache.log4j.Logger;
+import org.apache.logging.log4j.Logger;
 
 import com.framsticks.util.dispatching.ExceptionResultHandler;
@@ -28,3 +28,8 @@
 		};
 	}
+
+	public static <T> T passThru(Logger log, String header, T value) {
+		log.info("{}: {}", header, value);
+		return value;
+	}
 }
Index: java/main/src/main/java/com/framsticks/util/Misc.java
===================================================================
--- java/main/src/main/java/com/framsticks/util/Misc.java	(revision 99)
+++ java/main/src/main/java/com/framsticks/util/Misc.java	(revision 100)
@@ -1,5 +1,5 @@
 package com.framsticks.util;
 
-// import org.apache.log4j.Logger;
+// import org.apache.logging.log4j.Logger;
 
 /**
@@ -8,5 +8,5 @@
 public class Misc {
 	// private static final Logger log =
-	// 	Logger.getLogger(Misc.class);
+	// 	LogManager.getLogger(Misc.class);
 
 	public static class WithType {
@@ -34,5 +34,5 @@
 
 	public static boolean equals(Object a, Object b) {
-		// log.info("equality of " + withType(a) + " ? " + withType(b));
+		// log.info("equality of {} ? {}", withType(a), withType(b));
 		if (a != null) {
 			return (b != null && a.equals(b));
Index: java/main/src/main/java/com/framsticks/util/dispatching/AbstractJoinable.java
===================================================================
--- java/main/src/main/java/com/framsticks/util/dispatching/AbstractJoinable.java	(revision 99)
+++ java/main/src/main/java/com/framsticks/util/dispatching/AbstractJoinable.java	(revision 100)
@@ -10,5 +10,6 @@
 
 import org.apache.commons.collections.CollectionUtils;
-import org.apache.log4j.Logger;
+import org.apache.logging.log4j.Logger;
+import org.apache.logging.log4j.LogManager;
 
 import com.framsticks.util.FramsticksException;
@@ -16,5 +17,5 @@
 public abstract class AbstractJoinable implements Joinable {
 
-	private static final Logger log = Logger.getLogger(AbstractJoinable.class);
+	private static final Logger log = LogManager.getLogger(AbstractJoinable.class);
 
 	protected final Set<JoinableParent> owners = new HashSet<JoinableParent>();
@@ -41,5 +42,5 @@
 			}
 		}
-		log.debug("state: " + b);
+		log.debug("state: {}", b);
 	}
 
@@ -53,5 +54,5 @@
 		this.state = state;
 
-		log.debug(this + " is notifying " + joinableListeners.size() + " parents");
+		log.debug("{} is notifying {} parents", this, joinableListeners.size());
 
 		List<JoinableParent> parents = new LinkedList<>();
@@ -141,5 +142,5 @@
 			}
 			start = owners.isEmpty();
-			log.debug(owner + " is using " + this);
+			log.debug("{} is using {}", owner, this);
 			owners.add(owner);
 			joinableListeners.add(owner);
@@ -161,5 +162,5 @@
 			}
 			// assert owners.containsKey(owner);
-			log.debug(owner + " is droping " + this);
+			log.debug("{} is droping {}", owner, this);
 			owners.remove(owner);
 			stop = owners.isEmpty();
Index: java/main/src/main/java/com/framsticks/util/dispatching/Dispatching.java
===================================================================
--- java/main/src/main/java/com/framsticks/util/dispatching/Dispatching.java	(revision 99)
+++ java/main/src/main/java/com/framsticks/util/dispatching/Dispatching.java	(revision 100)
@@ -1,5 +1,6 @@
 package com.framsticks.util.dispatching;
 
-import org.apache.log4j.Logger;
+import org.apache.logging.log4j.Logger;
+import org.apache.logging.log4j.LogManager;
 
 import com.framsticks.util.FramsticksException;
@@ -9,5 +10,5 @@
  */
 public abstract class Dispatching {
-	private static final Logger log = Logger.getLogger(Dispatching.class);
+	private static final Logger log = LogManager.getLogger(Dispatching.class);
 
 	public static boolean isThreadSafe() {
@@ -57,30 +58,30 @@
 
 	public static void use(final Joinable joinable, final JoinableParent owner) {
-		log.debug("using " + joinable + " by " + owner);
+		log.debug("using {} by {}", joinable, owner);
 		if (joinable.use(owner)) {
-			log.debug("started " + joinable);
+			log.debug("started {}", joinable);
 		} else {
-			log.debug("start of " + joinable + " already happened");
+			log.debug("start of {} already happened", joinable);
 		}
 	}
 
 	public static void drop(final Joinable joinable, final JoinableParent owner) {
-		log.debug("droping " + joinable + " by " + owner);
+		log.debug("droping {} by {}", joinable, owner);
 		if (joinable.drop(owner)) {
-			log.debug("stoped " + joinable);
+			log.debug("stoped {}", joinable);
 		} else {
-			log.debug("stop of " + joinable + " deferred");
+			log.debug("stop of {} deferred", joinable);
 		}
 	}
 
 	public static void join(Joinable joinable) throws InterruptedException {
-		log.debug("joining " + joinable);
+		log.debug("joining {}", joinable);
 		try {
 			joinable.join();
 		} catch (InterruptedException e) {
-			log.debug("failed to join " + joinable);
+			log.debug("failed to join {}", joinable);
 			throw e;
 		}
-		log.debug("joined " + joinable);
+		log.debug("joined {}", joinable);
 	}
 
@@ -92,5 +93,5 @@
 			@Override
 			protected void runAt() {
-				log.debug("joinable " + joinable + " is notifying parent " + parent + " about change to " + state);
+				log.debug("joinable {} is notifying parent {} about change to {}", joinable, parent, state);
 				parent.childChangedState(joinable, state);
 			}
@@ -108,5 +109,5 @@
 
 	public static void joinAbsolutely(Joinable joinable) {
-		log.debug("joining absolutely " + joinable);
+		log.debug("joining absolutely {}", joinable);
 		while (true) {
 			try {
@@ -116,5 +117,5 @@
 				// throw new FramsticksException().msg("failed to join").arg("dispatcher", dispatcher).cause(e);
 			}
-			log.debug("waiting for " + joinable);
+			log.debug("waiting for {}", joinable);
 			wait(joinable, 500);
 		}
Index: java/main/src/main/java/com/framsticks/util/dispatching/DispatchingExceptionHandler.java
===================================================================
--- java/main/src/main/java/com/framsticks/util/dispatching/DispatchingExceptionHandler.java	(revision 100)
+++ java/main/src/main/java/com/framsticks/util/dispatching/DispatchingExceptionHandler.java	(revision 100)
@@ -0,0 +1,30 @@
+package com.framsticks.util.dispatching;
+
+import com.framsticks.util.FramsticksException;
+
+public class DispatchingExceptionHandler implements ExceptionResultHandler {
+
+	protected final Dispatcher<?> dispatcher;
+	protected final ExceptionResultHandler handler;
+
+	/**
+	 * @param dispatcher
+	 * @param handler
+	 */
+	public DispatchingExceptionHandler(Dispatcher<?> dispatcher, ExceptionResultHandler handler) {
+		this.dispatcher = dispatcher;
+		this.handler = handler;
+	}
+
+	@SuppressWarnings({ "rawtypes", "unchecked" })
+	@Override
+	public void handle(final FramsticksException exception) {
+		dispatcher.dispatch(new RunAt(ThrowExceptionHandler.getInstance()) {
+			@Override
+			protected void runAt() {
+				handler.handle(exception);
+			}
+		});
+	}
+
+}
Index: java/main/src/main/java/com/framsticks/util/dispatching/DispatchingFuture.java
===================================================================
--- java/main/src/main/java/com/framsticks/util/dispatching/DispatchingFuture.java	(revision 100)
+++ java/main/src/main/java/com/framsticks/util/dispatching/DispatchingFuture.java	(revision 100)
@@ -0,0 +1,43 @@
+package com.framsticks.util.dispatching;
+
+import com.framsticks.util.FramsticksException;
+
+public class DispatchingFuture<C, T> extends Future<T> {
+
+	protected final Dispatcher<? super C> dispatcher;
+	protected final Future<T> future;
+
+	/**
+	 * @param dispatcher
+	 * @param future
+	 */
+	public DispatchingFuture(Dispatcher<? super C> dispatcher, Future<T> future) {
+		this.dispatcher = dispatcher;
+		this.future = future;
+	}
+
+	@Override
+	public void handle(final FramsticksException exception) {
+		Dispatching.dispatchIfNotActive(dispatcher, new RunAt<C>(ThrowExceptionHandler.getInstance()) {
+			@Override
+			protected void runAt() {
+				future.handle(exception);
+			}
+		});
+	}
+
+	@Override
+	protected void result(final T result) {
+		Dispatching.dispatchIfNotActive(dispatcher, new RunAt<C>(future) {
+			@Override
+			protected void runAt() {
+				future.pass(result);
+			}
+		});
+	}
+
+	public static <Ca, Ta> Future<Ta> create(Dispatcher<Ca> dispatcher, Future<Ta> future) {
+		return new DispatchingFuture<Ca, Ta>(dispatcher, future);
+	}
+
+}
Index: java/main/src/main/java/com/framsticks/util/dispatching/Monitor.java
===================================================================
--- java/main/src/main/java/com/framsticks/util/dispatching/Monitor.java	(revision 99)
+++ java/main/src/main/java/com/framsticks/util/dispatching/Monitor.java	(revision 100)
@@ -1,5 +1,6 @@
 package com.framsticks.util.dispatching;
 
-import org.apache.log4j.Logger;
+import org.apache.logging.log4j.Logger;
+import org.apache.logging.log4j.LogManager;
 import com.framsticks.util.dispatching.Dispatching;
 import java.lang.Thread;
@@ -7,5 +8,5 @@
 public class Monitor implements JoinableParent {
 	private static final Logger log =
-		Logger.getLogger(Monitor.class);
+		LogManager.getLogger(Monitor.class);
 
 	protected final Joinable joinable;
@@ -30,5 +31,5 @@
 		Runtime.getRuntime().addShutdownHook(shutdownHook);
 
-		log.debug(this + " is using");
+		log.debug("{} is using", this);
 		Dispatching.use(joinable, this);
 		return this;
@@ -41,5 +42,5 @@
 
 	public Monitor waitFor() {
-		log.debug(this + " is waiting");
+		log.debug("{} is waiting", this);
 		synchronized (this) {
 			while (joinable.getState().ordinal() < JoinableState.FINISHING.ordinal()) {
@@ -47,5 +48,5 @@
 			}
 		}
-		log.debug(this + " ended waiting");
+		log.debug("{} ended waiting", this);
 		return this;
 	}
@@ -53,5 +54,5 @@
 
 	public Monitor drop() {
-		log.debug(this + " is droping");
+		log.debug("{} is droping", this);
 		Dispatching.drop(joinable, this);
 		return this;
@@ -59,7 +60,7 @@
 
 	public Monitor join() {
-		log.debug(this + " is joining");
+		log.debug("{} is joining", this);
 		Dispatching.joinAbsolutely(joinable);
-		log.debug(this + " is joined");
+		log.debug("{} is joined", this);
 
 		try {
@@ -78,5 +79,5 @@
 			this.notify();
 		}
-		log.debug(this + " received notification about transition to " + state);
+		log.debug("{} received notification about transition to {}", this, state);
 	}
 
Index: java/main/src/main/java/com/framsticks/util/dispatching/Thread.java
===================================================================
--- java/main/src/main/java/com/framsticks/util/dispatching/Thread.java	(revision 99)
+++ java/main/src/main/java/com/framsticks/util/dispatching/Thread.java	(revision 100)
@@ -1,5 +1,6 @@
 package com.framsticks.util.dispatching;
 
-import org.apache.log4j.Logger;
+import org.apache.logging.log4j.Logger;
+import org.apache.logging.log4j.LogManager;
 
 import java.util.LinkedList;
@@ -15,5 +16,5 @@
 public class Thread<C> extends AbstractJoinable implements JoinableDispatcher<C> {
 
-	private static final Logger log = Logger.getLogger(Thread.class);
+	private static final Logger log = LogManager.getLogger(Thread.class);
 
 	protected final java.lang.Thread thread;
@@ -46,5 +47,5 @@
 
 	protected void routine() {
-		log.debug("starting thread " + this);
+		log.debug("starting thread {}", this);
 		assert getMonitor() != null;
 		ExceptionHandler exceptionHandler = getMonitor().getTaskExceptionHandler();
@@ -83,5 +84,5 @@
 			}
 		}
-		log.debug("finishing thread " + this);
+		log.debug("finishing thread {}", this);
 		finish();
 	}
@@ -138,5 +139,5 @@
 	protected void joinableJoin() throws InterruptedException {
 		thread.join(500);
-		log.debug("joined " + this);
+		log.debug("joined {}", this);
 	}
 
Index: java/main/src/main/java/com/framsticks/util/lang/Casting.java
===================================================================
--- java/main/src/main/java/com/framsticks/util/lang/Casting.java	(revision 99)
+++ java/main/src/main/java/com/framsticks/util/lang/Casting.java	(revision 100)
@@ -29,3 +29,10 @@
 		return class_.cast(object);
 	}
+
+	public static <T> T nullOrThrowCast(Class<T> class_, Object object) {
+		if (object == null) {
+			return null;
+		}
+		return class_.cast(object);
+	}
 }
Index: java/main/src/main/java/com/framsticks/util/lang/FlagsUtil.java
===================================================================
--- java/main/src/main/java/com/framsticks/util/lang/FlagsUtil.java	(revision 99)
+++ java/main/src/main/java/com/framsticks/util/lang/FlagsUtil.java	(revision 100)
@@ -2,5 +2,6 @@
 
 import java.lang.reflect.Field;
-import org.apache.log4j.Logger;
+import org.apache.logging.log4j.Logger;
+import org.apache.logging.log4j.LogManager;
 
 import com.framsticks.util.lang.Delimeted;
@@ -8,5 +9,5 @@
 public final class FlagsUtil {
 
-	private final static Logger log = Logger.getLogger(FlagsUtil.class);
+	private final static Logger log = LogManager.getLogger(FlagsUtil.class);
 
 	private FlagsUtil() {
@@ -41,7 +42,7 @@
 					allFlags |= Integer.parseInt(field.get(null).toString());
 				} catch (SecurityException e) {
-					log.warn("security exception was thrown while trying to read flag (" + flag + ")");
+					log.warn("security exception was thrown while trying to read flag ({})", flag);
 				} catch (NoSuchFieldException | IllegalArgumentException | IllegalAccessException e) {
-					log.warn("selected flag is not known (" + flag + ")");
+					log.warn("selected flag is not known ({})", flag);
 				}
 			}
Index: java/main/src/main/java/com/framsticks/visualization/SingleViewPanel.java
===================================================================
--- java/main/src/main/java/com/framsticks/visualization/SingleViewPanel.java	(revision 99)
+++ java/main/src/main/java/com/framsticks/visualization/SingleViewPanel.java	(revision 100)
@@ -1,7 +1,7 @@
 package com.framsticks.visualization;
 
-import com.framsticks.gui.Panel;
+import com.framsticks.gui.TreePanel;
 import com.framsticks.model.Model;
-import com.framsticks.params.AccessInterface;
+import com.framsticks.params.Access;
 
 import javax.swing.*;
@@ -12,9 +12,9 @@
  */
 @SuppressWarnings("serial")
-public class SingleViewPanel extends Panel {
+public class SingleViewPanel extends TreePanel {
 
 	Viewer viewer;
 
-	public SingleViewPanel(Panel.Parameters parameters) {
+	public SingleViewPanel(TreePanel.Parameters parameters) {
 		super(parameters);
 		//viewer = new Viewer();
@@ -26,5 +26,5 @@
 
 	@Override
-	public void pullValuesFromLocalToUser(AccessInterface access) {
+	public void pullValuesFromLocalToUser(Access access) {
 		Object object = access.getSelected();
 		if (!(object instanceof Model)) {
Index: java/main/src/main/java/com/framsticks/visualization/SingleViewPanelProvider.java
===================================================================
--- java/main/src/main/java/com/framsticks/visualization/SingleViewPanelProvider.java	(revision 99)
+++ java/main/src/main/java/com/framsticks/visualization/SingleViewPanelProvider.java	(revision 100)
@@ -1,6 +1,6 @@
 package com.framsticks.visualization;
 
-import com.framsticks.gui.Panel;
 import com.framsticks.gui.PanelProvider;
+import com.framsticks.gui.TreePanel;
 
 /**
@@ -9,5 +9,5 @@
 public class SingleViewPanelProvider implements PanelProvider {
 	@Override
-	public Panel providePanel(Panel.Parameters parameters) {
+	public TreePanel providePanel(TreePanel.Parameters parameters) {
 		if (parameters.param.getContainedTypeName().equals("Model")) {
 			return new SingleViewPanel(parameters);
Index: java/main/src/main/java/com/framsticks/visualization/Viewer.java
===================================================================
--- java/main/src/main/java/com/framsticks/visualization/Viewer.java	(revision 99)
+++ java/main/src/main/java/com/framsticks/visualization/Viewer.java	(revision 100)
@@ -19,9 +19,10 @@
 import java.io.*;
 
-import org.apache.log4j.Logger;
+import org.apache.logging.log4j.Logger;
+import org.apache.logging.log4j.LogManager;
 
 public class Viewer {
 
-	private static Logger log = Logger.getLogger(Viewer.class);
+	private static Logger log = LogManager.getLogger(Viewer.class);
 
 	Canvas3D canvas3d;
Index: java/main/src/main/java/com/framsticks/visualization/ViewerTest.java
===================================================================
--- java/main/src/main/java/com/framsticks/visualization/ViewerTest.java	(revision 99)
+++ java/main/src/main/java/com/framsticks/visualization/ViewerTest.java	(revision 100)
@@ -3,5 +3,6 @@
 import com.sun.j3d.utils.universe.*;
 import com.sun.j3d.utils.geometry.ColorCube;
-import org.apache.log4j.Logger;
+import org.apache.logging.log4j.Logger;
+import org.apache.logging.log4j.LogManager;
 
 import javax.media.j3d.*;
@@ -17,5 +18,5 @@
 @SuppressWarnings("serial")
 public class ViewerTest extends JPanel {
-	private static final Logger log = Logger.getLogger(ViewerTest.class.getName());
+	private static final Logger log = LogManager.getLogger(ViewerTest.class.getName());
 
 	private SimpleUniverse univ = null;
